Object.defineProperty(exports, "__esModule", {
  value: true
});

exports['default'] = function (_ref) {
  var template = _ref.template;

  var buildImport = template('\n  (new Promise((resolve) => {\n    require.ensure([], (require) => {\n      resolve(require(SOURCE));\n    });\n  }))\n');

  return {
    // NOTE: Once we drop support for Babel <= v6 we should
    // update this to import from @babel/plugin-syntax-dynamic-import.
    // https://www.npmjs.com/package/@babel/plugin-syntax-dynamic-import
    manipulateOptions: function () {
      function manipulateOptions(opts, parserOpts) {
        parserOpts.plugins.push('dynamicImport');
      }

      return manipulateOptions;
    }(),

    visitor: {
      Import: function () {
        function Import(path) {
          var newImport = buildImport({
            SOURCE: path.parentPath.node.arguments
          });
          path.parentPath.replaceWith(newImport);
        }

        return Import;
      }()
    }
  };
};